## com.lowagie.text
Class Row

    java.lang.Object
      com.lowagie.text.Row

All Implemented Interfaces:
  Element, MarkupAttributes

    public class Row

extends java.lang.Object
implements Element, MarkupAttributes

A `Row` is part of a `Table` and contains some `Cells`.

All `Row`s are constructed by a `Table`-object. You don't have to construct any `Row` yourself. In fact you can't construct a `Row` outside the package.

Since a `Cell` can span several rows and/or columns a row can contain reserved space without any content.

See Also:
  `Element`, `Cell`, `Table`

Field Summary
`static int` `CELL` id of the Cell element in a Row
`protected java.lang.Object[]` `cells` This is the array of Objects (`Cell` or `Table`).
`protected int` `columns` This is the number of columns in the `Row`.
`protected int` `currentColumn` This is a valid position the `Row`.
`protected int` `horizontalAlignment` This is the vertical alignment.
`protected java.util.Properties` `markupAttributes` Contains extra markupAttributes
`static int` `NULL` id of a null element in a Row
`protected boolean[]` `reserved` This is the array that keeps track of reserved cells.
`static int` `TABLE` id of the Table element in a Row
`protected int` `verticalAlignment` This is the vertical alignment.

Constructor Summary
`protected` `Row(int columns)` Constructs a `Row` with a certain number of columns.

Method Summary
`(package private) int` `addElement(java.lang.Object element)` Adds a `Cell` to the `Row`.
`(package private) int` `addElement(java.lang.Object element, int column)` Adds an element to the `Row` at the position given.
`int` `columns()` Gets the number of columns.
`(package private) void` `deleteColumn(int column)` Returns a `Row` that is a copy of this `Row` in which a certain column has been deleted.
`java.lang.Object` `getCell(int column)` Gets a `Cell` or `Table` from a certain column.
`java.util.ArrayList` `getChunks()` Gets all the chunks in this element.
`(package private) int` `getElementID(int column)` Returns the type-id of the element in a Row.
`java.lang.String` `getMarkupAttribute(java.lang.String name)` Returns the value of the specified attribute.
`java.util.Set` `getMarkupAttributeNames()` Returns a `Set` of `String` attribute names for the `MarkupAttributes` implementor.
`java.util.Properties` `getMarkupAttributes()` Return a `Properties`-object containing all the markupAttributes.
`(package private) int` `getObjectID(java.lang.Object element)` Returns the type-id of an Object.
`int` `horizontalAlignment()` Gets the horizontal alignment.
`boolean` `isEmpty()` Checks if the row is empty.
`(package private) boolean` `isReserved(int column)` Returns true/false when this position in the `Row` has been reserved, either filled or through a colspan of an Element.
`static boolean` `isTag(java.lang.String tag)` Checks if a given tag corresponds with this object.
`boolean` `process(ElementListener listener)` Processes the element by adding it (or the different parts) to a `ElementListener`.
`(package private) boolean` `reserve(int column)` Reserves a `Cell` in the `Row`.
`(package private) boolean` `reserve(int column, int size)` Reserves a `Cell` in the `Row`.
`(package private) void` `setElement(java.lang.Object aElement, int column)` Puts `Cell` to the `Row` at the position given, doesn't reserve colspan.
`void` `setHorizontalAlignment(int value)` Sets the horizontal alignment.
`void` `setMarkupAttribute(java.lang.String name, java.lang.String value)` Sets the specified attribute.
`void` `setMarkupAttributes(java.util.Properties markupAttributes)` Sets the markupAttributes.
`void` `setVerticalAlignment(int value)` Sets the vertical alignment.
`int` `type()` Gets the type of the text element.
`(package private) int` `validPosition()` Gets the index of the current, valid position
`int` `verticalAlignment()` Gets the vertical alignment.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NULL

    public static final int NULL

  id of a null element in a Row

  See Also:
    Constant Field Values

### CELL

    public static final int CELL

  id of the Cell element in a Row

  See Also:
    Constant Field Values

### TABLE

    public static final int TABLE

  id of the Table element in a Row

  See Also:
    Constant Field Values

### columns

    protected int columns

  This is the number of columns in the `Row`.

### currentColumn

    protected int currentColumn

  This is a valid position the `Row`.

### reserved

    protected boolean[] reserved

  This is the array that keeps track of reserved cells.

### cells

    protected java.lang.Object[] cells

  This is the array of Objects (`Cell` or `Table`).

### horizontalAlignment

    protected int horizontalAlignment

  This is the vertical alignment.

### verticalAlignment

    protected int verticalAlignment

  This is the vertical alignment.

### markupAttributes

    protected java.util.Properties markupAttributes

  Contains extra markupAttributes

Constructor Detail

### Row

    protected Row(int columns)

  Constructs a `Row` with a certain number of columns.

  Parameters:
    `columns` - a number of columns

Method Detail

### process

    public boolean process(ElementListener listener)

  Processes the element by adding it (or the different parts) to a `ElementListener`.

  Specified by:
    `process` in interface `Element`
  Parameters:
    `listener` - an `ElementListener`
  Returns:
    `true` if the element was processed successfully

### type

    public int type()

  Gets the type of the text element.

  Specified by:
    `type` in interface `Element`
  Returns:
    a type

### getChunks

    public java.util.ArrayList getChunks()

  Gets all the chunks in this element.

  Specified by:
    `getChunks` in interface `Element`
  Returns:
    an `ArrayList`

### deleteColumn

    void deleteColumn(int column)

  Returns a `Row` that is a copy of this `Row` in which a certain column has been deleted.

  Parameters:
    `column` - the number of the column to delete

### addElement

    int addElement(java.lang.Object element)

  Adds a `Cell` to the `Row`.

  Parameters:
    `element` - the element to add (currently only Cells and Tables supported)
  Returns:
    the column position the `Cell` was added, or `-1` if the `element` couldn't be added.

### addElement

    int addElement(java.lang.Object element,
                   int column)

  Adds an element to the `Row` at the position given.

  Parameters:
    `element` - the element to add. (currently only Cells and Tables supported
    `column` - the position where to add the cell.
  Returns:
    the column position the `Cell` was added, or `-1` if the `Cell` couldn't be added.

### setElement

    void setElement(java.lang.Object aElement,
                    int column)

  Puts `Cell` to the `Row` at the position given, doesn't reserve colspan.

  Parameters:
    `aElement` - the cell to add.
    `column` - the position where to add the cell.

### reserve

    boolean reserve(int column)

  Reserves a `Cell` in the `Row`.

  Parameters:
    `column` - the column that has to be reserved.
  Returns:
    `true` if the column was reserved, `false` if not.

### reserve

    boolean reserve(int column,
                    int size)

  Reserves a `Cell` in the `Row`.

  Parameters:
    `column` - the column that has to be reserved.
    `size` - the number of columns
  Returns:
    `true` if the column was reserved, `false` if not.

### setHorizontalAlignment

    public void setHorizontalAlignment(int value)

  Sets the horizontal alignment.

  Parameters:
    `value` - the new value

### setVerticalAlignment

    public void setVerticalAlignment(int value)

  Sets the vertical alignment.

  Parameters:
    `value` - the new value

### isReserved

    boolean isReserved(int column)

  Returns true/false when this position in the `Row` has been reserved, either filled or through a colspan of an Element.

  Parameters:
    `column` - the column.
  Returns:
    `true` if the column was reserved, `false` if not.

### getElementID

    int getElementID(int column)

  Returns the type-id of the element in a Row.

  Parameters:
    `column` - the column of which you'd like to know the type
  Returns:
    the type-id of the element in the row

### getObjectID

    int getObjectID(java.lang.Object element)

  Returns the type-id of an Object.

  Parameters:
    `element` - the object of which you'd like to know the type-id, -1 if invalid
  Returns:
    the type-id of an object

### getCell

    public java.lang.Object getCell(int column)

  Gets a `Cell` or `Table` from a certain column.

  Parameters:
    `column` - the column the `Cell/Table` is in.
  Returns:
    the `Cell`,`Table` or Object if the column was reserved or null if empty.

### isEmpty

    public boolean isEmpty()

  Checks if the row is empty.

  Returns:
    `true` if none of the columns is reserved.

### validPosition

    int validPosition()

  Gets the index of the current, valid position

  Returns:
    a value

### columns

    public int columns()

  Gets the number of columns.

  Returns:
    a value

### horizontalAlignment

    public int horizontalAlignment()

  Gets the horizontal alignment.

  Returns:
    a value

### verticalAlignment

    public int verticalAlignment()

  Gets the vertical alignment.

  Returns:
    a value

### isTag

    public static boolean isTag(java.lang.String tag)

  Checks if a given tag corresponds with this object.

  Parameters:
    `tag` - the given tag
  Returns:
    true if the tag corresponds

### setMarkupAttribute

    public void setMarkupAttribute(java.lang.String name,
                                   java.lang.String value)

  Description copied from interface: `MarkupAttributes`
  Sets the specified attribute.

  Specified by:
    `setMarkupAttribute` in interface `MarkupAttributes`
  Parameters:
    `name` - `String` attribute name.
    `value` - `String` attribute value.
  See Also:
    `MarkupAttributes.setMarkupAttribute(java.lang.String, java.lang.String)`

### setMarkupAttributes

    public void setMarkupAttributes(java.util.Properties markupAttributes)

  Description copied from interface: `MarkupAttributes`
  Sets the markupAttributes.

  Specified by:
    `setMarkupAttributes` in interface `MarkupAttributes`
  Parameters:
    `markupAttributes` - a `Properties`-object containing markupattributes
  See Also:
    `MarkupAttributes.setMarkupAttributes(java.util.Properties)`

### getMarkupAttribute

    public java.lang.String getMarkupAttribute(java.lang.String name)

  Description copied from interface: `MarkupAttributes`
  Returns the value of the specified attribute.

  Specified by:
    `getMarkupAttribute` in interface `MarkupAttributes`
  Parameters:
    `name` - `String` attribute name.
  Returns:
    `String`.
  See Also:
    `MarkupAttributes.getMarkupAttribute(java.lang.String)`

### getMarkupAttributeNames

    public java.util.Set getMarkupAttributeNames()

  Description copied from interface: `MarkupAttributes`
  Returns a `Set` of `String` attribute names for the `MarkupAttributes` implementor.

  Specified by:
    `getMarkupAttributeNames` in interface `MarkupAttributes`
  Returns:
    `Set`.
  See Also:
    `MarkupAttributes.getMarkupAttributeNames()`

### getMarkupAttributes

    public java.util.Properties getMarkupAttributes()

  Description copied from interface: `MarkupAttributes`
  Return a `Properties`-object containing all the markupAttributes.

  Specified by:
    `getMarkupAttributes` in interface `MarkupAttributes`
  Returns:
    `Properties`
  See Also:
    `MarkupAttributes.getMarkupAttributes()`